
package engine;

import memory.*;

import java.lang.reflect.*;

/**
Aufruf eine Methode der untergeordneten Maschine (JVM).
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die
Free Software Foundation, Inc.,
59 Temple Place,
Suite 330,
Boston, MA 02111-1307,
USA.
*/
public class _call extends Command {

 /*
 Creator*
 */
 public _call() {
  name = "call";
 }

 /**
  Methode starten.
  Nachher ist auf dem Stack der Returnwert oder nichts, wenn void-Methode.
  @param machine Verbindung zur V2M.
  */
 public void runTime( V2M machine) {
 String  name  = (String)List.pop( machine.DS); // TOS --> method name
 Object  inst  =         List.pop( machine.DS); // TOS --> object instance
 int     idx   = name.indexOf( "{");
 String  mname = name.substring( 0, idx).trim();
 String  argl  = name.substring( idx+1, name.lastIndexOf( "}")).trim();
 Class[] args  = null;
 Method  method = null;

  args = machine.argClasses( argl);
  try   {
         method = inst.getClass().getMethod( mname, args);
        }
  catch (NoSuchMethodException nsm)
        {
         System.out.println( "Methode ["+mname+"] nicht gefunden");
        }

if (inst   == null) System.out.println( "Keine Instanz!!!!!");
if (method == null) System.out.println( "Keine Methode!!!!!");

  machine.invokation( inst, method);
 }
}
