
package engine;

import memory.*;

/**
Klasse zum Beenden der allgemeinen Schleife der V2M.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die
Free Software Foundation, Inc.,
59 Temple Place,
Suite 330,
Boston, MA 02111-1307,
USA.
*/
public class _endloop extends Command {

 /**
 Creator
 */
 public _endloop() {
  immediate = true;
  name      = "endloop";
 }

 /**
 Laufzeitverhalten des Commands.
 Ende des zu wiederholenden Abschnitts ermitteln, Sprungziel in 
 "_jumpt" (Jump_on_true) setzen.
 "_back" mit Sprungziel Schleifenanfang kompilieren.
 @param machine Verbindung zur V2M.
 */
 public void runTime( V2M machine) {
 _back  bck = new _back();                     // unbedingte Rück-Sprunganweisung
 Object obj = List.pop( machine.DS);   // Objekt (index oder _jumpt) vom Datenstack holen

  List.append( machine.HERE, bck);   // Rück-Sprunganweisung compilieren
  if (obj instanceof _jump)                    // Test, ob Leave oder Index
     {
      ((_jump)obj).destination = machine.HERE.last; // LEAVE-Sprungziel setzen
      ((_jump)obj).index = List.length( machine.HERE);
      obj = List.pop( machine.DS);     // Objekt (index) vom Datenstack holen
     }
 int idx = ((Integer)obj).intValue();
  bck.destination = List.getItem( machine.HERE, idx); // Ziel der Rück-Sprunganweisung setzen
  bck.index = idx;
 }
}
