
package engine;

import memory.*;

/**
Klasse der allgemeinen Wiederholungsanweisung der V2M.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die
Free Software Foundation, Inc.,
59 Temple Place,
Suite 330,
Boston, MA 02111-1307,
USA.
*/
public class _loop extends Command {

 /**
 Creator
 */
 public _loop() {
  immediate = true;
  name      = "loop";
 }

 /**
 Laufzeitverhalten des Commands.
 Es ist die allgemeinste Schleifenkonstruktion. Sie kann zusammen mit
 dem Command "leave" alle etablierten (while, do-while, for, repeat-until) 
 erzetzen.
 @param machine Verbindung zur V2M.
 */
 public void runTime( V2M machine) {
  // Anfang des zu wiederholenden Abschnitts ermitteln.
  List.push( machine.DS, new Integer( List.length( machine.HERE))); // Position des Schleifenbeginns auf Datenstack merken
 }
}
