
package engine;

import memory.*;

/**
Klasse zur Aufnahme einer Methode der untergeordneten Maschine in den Sprachschatz.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die
Free Software Foundation, Inc.,
59 Temple Place,
Suite 330,
Boston, MA 02111-1307,
USA.
*/
public class _method extends Command {

 /**
 Creator
 */
 public _method() {
  name = "method";
 }

 /**
 Methode als Command compilieren.
 Aus einer Java-Methode wird ein Command der V2M.
 Die Argumente müssen vor dem Aufruf des Commands auf dem Stack liegen.
 @param machine Verbindung zur V2M.
 */
 public void runTime( V2M machine) {
 String  name  = (String)List.pop( machine.DS); // TOS --> method name
 Object  inst  = machine.DS.first.content;      // TOS --> object instance
 int     idx   = name.indexOf( "{");
 String  mname = name.substring( 0, idx).trim();
 String  argl  = name.substring( idx+1, name.lastIndexOf( "}")).trim();
 Class[] args  = null;

  args = machine.argClasses( argl);
  try   {

         if  (machine.DS.first.content instanceof Class)
              List.push( machine.DS,   ((Class)inst).getMethod( mname, args)); // --> class  method
         else List.push( machine.DS, inst.getClass().getMethod( mname, args)); // --> object method
        }
  catch (NoSuchMethodException nsm)
        {
         System.out.println( "Method ["+mname+"] not found");
         return;
        }

 Command meth = new _meth();     // leeres _meth erstellen
  meth.name = machine.getWord(); // _meth mit Namen versehen
  meth.commands = new List();    // _meth Anweisungsliste aufbauen
  List.append( meth.commands, List.pop( machine.DS)); // method
  List.append( meth.commands, List.pop( machine.DS)); // instance
  List.push( machine.DICT, meth);  // _meth ins Dictionary intergrieren
 }
}
