
package engine;

import memory.*;

/**
Klasse der Negation.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die
Free Software Foundation, Inc.,
59 Temple Place,
Suite 330,
Boston, MA 02111-1307,
USA.
*/
public class _not extends Command {

 /**
 Creator
 */
 public _not() {
  name = "not";
 }

 /**
 Laufzeitverhalten des Commands.
 Zahlen werden durch bitweise Negation (toggling) negiert.
 @param machine Verbindung zur V2M.
 */
 public void runTime( V2M machine) {
 Object x = List.pop( machine.DS);
  if (x instanceof Boolean)
     {
      List.push( machine.DS, new Boolean( !((Boolean)x).booleanValue()));
      return;
     }
 Number a = (Number)x;
 Number c = null;
       if (a instanceof Long)    c = new Long(          ~a.longValue());
  else if (a instanceof Integer) c = new Integer(       ~a.intValue());
  else if (a instanceof Short)   c = new Short( (short)(~a.shortValue()));
  else if (a instanceof Byte)    c = new Byte(   (byte)(~a.byteValue()));
  else {
         System.out.println( name+ " mit ["+a.getClass().getName()+"] nicht erlaubt.");
         return;
        }
  List.push( machine.DS, c);
 }
}
