
package engine;

import memory.*;

import java.lang.reflect.*;

/**
Klasse zur Belegung eines Fields mit Inhalten.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die
Free Software Foundation, Inc.,
59 Temple Place,
Suite 330,
Boston, MA 02111-1307,
USA.
*/
class _set extends Command {

 /**
 Creator
 */
 public _set() {
  this.name = "set";
 }

 /**
 Laufzeitverhalten des Commands.
 Objekt mit Inhalt des Fields belegen und auf dem Datenstack ablegen.
 @param machine Verbindung zur V2M.
 */
 public void runTime( V2M machine) {
 Command fld = machine.getCommand( (String)List.pop( machine.DS));
 Field  field  = (Field)fld.commands.first.content;

  try   {
         field.set( List.getObj( fld.commands, 1), List.pop( machine.DS));
        }
  catch (IllegalArgumentException iae)
        {
         System.out.println( "In \"_fld\": Fehlerhafter Zugriff auf Inhalt");
        }
  catch (IllegalAccessException   iac)
        {
         System.out.println( "Fehlerhafter Zugriff auf Field");
        }
 }
}
