
package memory;

/**
Klasse einer Objektliste mit gleichzeitiger Eigenschaft List und Stack.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version. 
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License. 
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die 
Free Software Foundation, Inc.,
59 Temple Place, 
Suite 330, 
Boston, MA 02111-1307, 
USA.
*/
public class List{
public Item first = null;
public Item last  = null;

 /**
 A list creator to build a new list out of an item.
 @param item element which is the first one in the nes list.
 @return
 */
 static public List build( Item item) {
 List list = new List();

  list.first = item;
  list.last  = item;
  while (item != null)
        {
         if (item != null) list.last = item;
         item = item.next;
        }
  return list;
 }

 /**
 Anzahl der Elemente in der Liste ermitteln.
 @param list Zu untersuchende Liste.
 @return Anzahl der Elemente.
 */
 static public int length( List list) {
 int  len = 0;
 Item itm = list.first;

  while (itm != null)
         {
          len++;
          itm = itm.next;
         }
  return len;
 }

 /**
 Puts a new list element at the end.
 @param list expanding list.
 @param obj object for new item.
 */
 static public void append( List list, Object obj) {
 Item item = new Item( obj);
  if (list.last == null)
     {
      list.last  = item;
      list.first = item;
      return;
     }
  item.prev      = list.last; // neu !!!!!
  list.last.next = item;
  list.last      = list.last.next;
 }

 /**
 Puts a new list element as start of the list.
 @param list expanding list.
 @param item object for new item.
 */
 static public void push( List list, Object obj) {
 Item item = new Item( obj);
  item.next = list.first;
  if (list.first != null) list.first.prev = item;
  list.first = item;
  if (list.last == null) list.last = list.first;
 }

 /**
 Eintrag vom Anfang der Liste entfernen und ausgeben.
 @param list Betroffene Liste.
 @return Eintrag aus der Liste.
 */
 static public Object pop( List list) {
 Item item = list.first;

  list.first = item.next;
  if (list.first != null) list.first.prev = null;
 Object obj = item.content;
  item.next    = null;
  item.prev    = null;
  item.content = null;
  return obj;
 }

 /**
 Get indexed element of a list.
 @param list containing list.
 @param ord index of the list item.
 @return object from indexed item.
 */
 static public Object getObj( List list, long ord) {
 Item item = list.first;
 long i    = 0;

 while (i<ord)
        {
         item = item.next;
         i++;
        }
  return item.content;
 }

 /**
 Get indexed item of a list.
 @param list containing list.
 @param ord index of the list item.
 @return indexed item.
 */
 static public Item getItem( List list, long ord) {
 Item item = list.first;
 long i    = 0;

 while (i<ord)
        {
         item = item.next;
         i++;
        }
  return item;
 }
}
