
package parsing;

/**
Klasse zur Bereistellung eines Operators.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die
Free Software Foundation, Inc.,
59 Temple Place,
Suite 330,
Boston, MA 02111-1307,
USA.
*/
public class Operator {
private String name  = null;
private int    prior = -1;

 /**
 Creator eines Operators.
 @param n Bezeichnung des Operators (NUR ein Zeichen).
 @param p Priorotät des Operators >0.
 @return Operator
 */
 static public Operator create( String n, int p) {
 Operator o = new Operator();

  o.name  = n;
  o.prior = p;
  return o;
 }

 /**
 Bezeichnung eines Operators übergeben.
 @param o Operator, dessen Bezeichnung gesucht ist.
 @return Bezeichnung
 */
 static public String nameOf( Operator o) {
  return o.name;
 }

 /**
 Priorität eines Operators übergeben.
 @param o Operator, dessen Priorität gesucht ist.
 @return Priorität
 */
 static public int priorityOf( Operator o) {
  return o.prior;
 }
}
