
package parsing;

import memory.*;

/**
Klasse zur Bereistellung der bekannten Operatoren (hier NUR für Weiterentwicklung).
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die
Free Software Foundation, Inc.,
59 Temple Place,
Suite 330,
Boston, MA 02111-1307,
USA.
*/
public class Operators {
static private List list = new List();

 /**
 Liste der Operatoren erweitern.
 Operatoren sind Strings der Länge 1. Es gibt vier Ausnahmen:
 !=, <>, <= und >=. Diese Operatoren sind vordefiniert. Weitere
 Operatoren mit mehreren Zeichen müssen programmiert werden.
 @param name Name des Operators.
 @param prior Priorität des Operators.
 */
 static public void append( String name, int prior) {
  List.append( list, Operator.create( name, prior));
 }
 
 /**
 Test, ob in der Liste der Operatoren die gesuchte ist.
 @param name Möglicher Operatorname. Wenn dieser Name eine Funktion (Methode)
             bezeichnet, gilt er trotzdem (auch) als Operator, denn Funktionen sind nach
             dem Parsen um "(" erweitert.
 @return found true wenn Argument ein bekannter Operator ist, sonst false.
 */
 static public boolean contains( String name) {
 boolean  found = false;
 Item     item  = list.first;
 Operator op    = null;

  while ((item != null) && !found)
        {
         op = (Operator)item.content;
         if   (name.endsWith( "("))
               found = "(".equals( Operator.nameOf( op));
         else found = name.equals( Operator.nameOf( op));
         if (!found) item = item.next;
        }
  return found;
 }

 /**
 Priorität eines Operators übergeben.
 @param name Möglicher Operatorname. Wenn dieser Name eine Funktion (Methode)
             bezeichnet, gilt er trotzdem (auch) als Operator, denn Funktionen sind nach
             dem Parsen um "(" erweitert.
 @return Wenn gefunden dann Priorität des Operators, sonst -1
 */
 static public int getPrior( String name) {
 boolean  found = false;
 Item     item  = list.first;
 Operator op    = null;

  while ((item != null) && !found)
        {
         op = (Operator)item.content;
         if   (name.endsWith( "("))
               found = "(".equals( Operator.nameOf( op));
         else found = name.equals( Operator.nameOf( op));
         if (!found) item = item.next;
        }
  if (found) return Operator.priorityOf( op);

  System.out.println( "Operator ["+name+"] nicht gefunden.");
  System.exit( 1);
  return -1;
 }
}
